/* the first C++ program
 * - just outputs `Hello, World!'
 */

#include <iostream>    // declarations for I/O
#include <ode/ode.h>
#include <GL/glut.h>
#include <SDL/SDL.h>
 
static dWorldID world; // notre monde
static dSpaceID space; // l'espace
static dGeomID sol;    // pour crer un sol infini
static dJointGroupID contactgroup;
 
GLUquadricObj *sphere; // une sphre grce a GLU
 
int stop = 0,
    h = 640, l = 480,
    LDEmouse_x  =   0, // la position X du cursor sur l'ecran en pixels
    LDEmouse_y  =   0, // la position Y du cursor sur l'ecran en pixels
    LDEmouse_X  =   0, // la force sur l'axe X du mouse
    LDEmouse_Y  =   0; // la force sur l'axe Y du mouse
SDL_Event evenement;
float cam_rx = 0, cam_ry = 32;
 
 
dBodyID body_cube, body_sphere;
dGeomID geom_cube, geom_speher;


static void nearCallback(void *data, dGeomID o1, dGeomID o2)
{
  int i;
  // exit without doing anything if the two bodies are connected by a joint
  dBodyID b1 = dGeomGetBody(o1);
  dBodyID b2 = dGeomGetBody(o2);
  if (b1 && b2 && dAreConnected (b1,b2)) return;
 
  dContact contact[3];			// up to 3 contacts per box
  for (i=0; i<3; i++)
  {
    contact[i].surface.mode = dContactSoftCFM | dContactApprox1;
    contact[i].surface.mu = 30;
    contact[i].surface.soft_cfm = 0.2;
  }
  if ( !dGeomGetBody(o1) & !dGeomGetBody(o2)); else
  if (int numc = dCollide (o1,o2,3,&contact[0].geom,sizeof(dContact)))
  {
    for (i=0; i<numc; i++)
    {
      dJointID c = dJointCreateContact (world,contactgroup,contact+i);
      dJointAttach (c,b1,b2);
    }
  }
}
 
void grille(float g,float l/*double *axes_color,double *grid_color*/)
 {  
 	glPushMatrix();
 	glScalef(l,l,l);
 	// dbut du dessin de la grille
 	glLineWidth(2); glBegin(GL_LINES);
 	//glColor3dv(axes_color);  glVertex3f(g,0,0);
 	glVertex3f(-g,0,0);
 	glVertex3f(0,0,g);
 	glVertex3f(0,0,-g);
 	glEnd();
 	glLineWidth(1);
 	glBegin(GL_LINES);
 	for (int i = 1; i <= g; ++i)
 	   {  
 	       //glColor3dv(grid_color);
 	       //les lignes sur l'axe X
 	       glVertex3f(-g,0, i);
 	       glVertex3f( g,0, i);
 	       glVertex3f(-g,0,-i);
 	       glVertex3f( g,0,-i);
 	       //les lignes sur l'axe Z
 	       glVertex3f(-i,0, g);
 	       glVertex3f(-i,0,-g);
 	       glVertex3f( i,0, g);
 	       glVertex3f( i,0,-g);
 	    }  
 	 glEnd();
     glPopMatrix();
 	 glColor3d(1,1,1);
 }	    
 
 void glCube(float x,float y,float z)
{
    glPushMatrix();
    glScalef(x/2,y/2,z/2);
    glBegin (GL_QUADS);
    //face 1
    glNormal3i(-1, 1,-1);
    glTexCoord2i(0,1);
    glVertex3i(-1, 1,-1);
    glNormal3i( 1, 1,-1);
    glTexCoord2i(1,1);
    glVertex3i( 1, 1,-1);
    glNormal3i( 1,-1,-1);
    glTexCoord2i(1,0);
    glVertex3i( 1,-1,-1);
    glNormal3i(-1,-1,-1);
    glTexCoord2i(0,0);
    glVertex3i(-1,-1,-1);
    //face 2
    glNormal3i(-1,-1,-1);
    glTexCoord2i(0,1);
    glVertex3i(-1,-1,-1);
    glNormal3i( 1,-1,-1);
    glTexCoord2i(1,1);
    glVertex3i( 1,-1,-1);
    glNormal3i( 1,-1, 1);
    glTexCoord2i(1,0);
    glVertex3i( 1,-1, 1);
    glNormal3i(-1,-1, 1);
    glTexCoord2i(0,0);
    glVertex3i(-1,-1, 1);
    // face 3
    glNormal3i( 1,-1, 1);
    glTexCoord2i(0,1);
    glVertex3i( 1,-1, 1);
    glNormal3i( 1,-1,-1);
    glTexCoord2i(1,1);
    glVertex3i( 1,-1,-1);
    glNormal3i( 1, 1,-1);
    glTexCoord2i(1,0);
    glVertex3i( 1, 1,-1);
    glNormal3i( 1, 1, 1);
    glTexCoord2i(0,0);
    glVertex3i( 1, 1, 1);
    //face 4
    glNormal3i( 1, 1,-1);
    glTexCoord2i(0,1);
    glVertex3i( 1, 1,-1);
    glNormal3i(-1, 1,-1);
    glTexCoord2i(1,1);
    glVertex3i(-1, 1,-1);
    glNormal3i(-1, 1, 1);
    glTexCoord2i(1,0);
    glVertex3i(-1, 1, 1);
    glNormal3i( 1, 1, 1);
    glTexCoord2i(0,0);
    glVertex3i( 1, 1, 1);
    //face 5
    glNormal3i(-1, 1, 1);
    glTexCoord2i(0,1);
    glVertex3i(-1, 1, 1);
    glNormal3i(-1, 1,-1);
    glTexCoord2i(1,1);
    glVertex3i(-1, 1,-1);
    glNormal3i(-1,-1,-1);
    glTexCoord2i(1,0);
    glVertex3i(-1,-1,-1);
    glNormal3i(-1,-1, 1);
    glTexCoord2i(0,0);
    glVertex3i(-1,-1, 1);
    //face 6
    glNormal3i( 1,-1, 1);
    glTexCoord2i(0,1);
    glVertex3i( 1,-1, 1);
    glNormal3i( 1, 1, 1);
    glTexCoord2i(1,1);
    glVertex3i( 1, 1, 1);
    glNormal3i(-1, 1, 1);
    glTexCoord2i(1,0);
    glVertex3i(-1, 1, 1);
    glNormal3i(-1,-1, 1);
    glTexCoord2i(0,0);
    glVertex3i(-1,-1, 1);
    glEnd();
    glPopMatrix();
}

 
void LDEsetM(const dReal *pos,const dReal *R)
{
    //LDEfloat local_matrix[16];
    float local_matrix[16];
    local_matrix[0]     =     R[0];
    local_matrix[1]     =     R[4];
    local_matrix[2]     =     R[8];
    local_matrix[3]     =     0;
    local_matrix[4]     =     R[1];
    local_matrix[5]     =     R[5];
    local_matrix[6]     =     R[9];
    local_matrix[7]     =     0;
    local_matrix[8]     =     R[2];
    local_matrix[9]     =     R[6];
    local_matrix[10]    =     R[10];
    local_matrix[11]    =     0;
    local_matrix[12]    =     pos[0];
    local_matrix[13]    =     pos[1];
    local_matrix[14]    =     pos[2];
    local_matrix[15]    =     1;
    glMultMatrixf(local_matrix);
}

 
int main(int argc,char *argv[])
{
    SDL_SetVideoMode(h,l,32,SDL_OPENGL
                           |SDL_FULLSCREEN
                           ); // on init SDL
 
    SDL_ShowCursor(0); // on cache le cursor
 
    sphere = gluNewQuadric(); // on initialise la sphere glu
 
    /// Some OpenGL settings
    GLfloat lumiere_couleur[] = {1,1,1,1};  // on indique la couleur
    glMaterialfv(GL_FRONT,GL_SHININESS,lumiere_couleur); // on set la couleur
    glEnable(GL_LIGHT0);               // on active la lumiere 0 d'OpenGL
    glEnable(GL_LIGHTING);
    glClearColor(0.7,0.7,0.7,0); // la couleur du fond d'cran
    glEnable(GL_COLOR_MATERIAL);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_NORMALIZE);
    ///
 
    /// on vas initialiser ODE
    world = dWorldCreate(); 		// on cre le monde
    space = dHashSpaceCreate(0); 	// et on cre l'espace
    dWorldSetGravity (world,0,-1,0); // on indique la gravit
    ///
 
    /// on vas crer nos onjets ODE (le cube ,la sphere) et le sol.
    sol = dCreatePlane (space,0,1,0,0);   // on cre le sol
 
    dMass m;
 
    // le cube
    dMassSetBox (&m,1,1,1,1);
    dMassAdjust(&m,0.2); // on indique la ca masse
    body_cube = dBodyCreate(world); // on cre le cube dans notre monde
    dBodySetMass(body_cube,&m); //
    geom_cube = dCreateBox(space,1,1,1); // on cre la gomtrie
    dGeomSetBody(geom_cube,body_cube); // on atache la geometrie au corp
    dGeomSetPosition(geom_cube,0,4,0); // on indique sa position
    //
 
    // la sphere
    dMassSetSphere(&m,1,1);
    dMassAdjust(&m,1);
    body_sphere = dBodyCreate(world);
    dBodySetMass(body_sphere,&m);
    dGeomID geom_sphere;
    geom_sphere = dCreateSphere(space,1);
    dGeomSetBody(geom_sphere,body_sphere);
    dBodySetPosition(body_sphere,4,5,0);
    //
    ///
 /// boucle ///
    while(!stop)
    {
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT); // refresh opengl
 
        /// les controls SDL
        SDL_PollEvent(&evenement);
        SDL_GetMouseState(&LDEmouse_x,&LDEmouse_y);
        SDL_GetRelativeMouseState(&LDEmouse_X,&LDEmouse_Y);
        if ( evenement.type == SDL_KEYDOWN && evenement.key.keysym.sym == SDLK_F9 ) stop = 1;
        ///
 
        /// on arrange le contexte OpenGL
        glViewport(0,0,h,l);
        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        gluPerspective(45,(float)h/(float)l,0.1,4000);
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        ///
 
        /// on fais les changements ODE
        dSpaceCollide(space,0,&nearCallback); // teste les collisions entre les objets
        dWorldQuickStep(world,0.01);       // a chaque frame, calcule la nouvelle position des objets
        ///
 
        /// camera
        glTranslatef(0,0,-5);
        glRotatef(cam_rx,1,0,0);
        glRotatef(cam_ry,0,1,0);
        glTranslatef(-dGeomGetPosition(geom_cube)[0],
                     -dGeomGetPosition(geom_cube)[1],
                     -dGeomGetPosition(geom_cube)[2]);
        // if ( evenement.type == SDL_MOUSEBUTTONDOWN && evenement.button.button == SDL_BUTTON_LEFT )
        {
            cam_rx += (float)LDEmouse_Y/2;
            cam_ry += (float)LDEmouse_X/2;
        }
        ///
 
        glColor3d(1,0,0);
        glDisable(GL_LIGHTING);
        grille(20,2); // le sol
        glEnable(GL_LIGHTING);
 
        /// on affiche notre cube & sphere
        // le cube
        glPushMatrix();
        glColor3d(1,0.5,5);
        LDEsetM(dBodyGetPosition(body_cube),dBodyGetRotation(body_cube));
        glCube(1,1,1);
        glPopMatrix();
        //
 
        //sphere
        glPushMatrix();
        LDEsetM(dBodyGetPosition(body_sphere),dBodyGetRotation(body_sphere));
        gluSphere(sphere,1,15,10);
        glPopMatrix();
        ///
 
        SDL_GL_SwapBuffers();             // Swap Buffers
    }
 
    dSpaceDestroy (space);
    dWorldDestroy (world);
    dCloseODE(); // on ferme ODE
}
